//
//  NSWindow+NisusCore.h
//  NisusCore
//
//  Created by Martin on 2013.10.11.
//  Copyright (c) 2013 Nisus. All rights reserved.
//

#import <Cocoa/Cocoa.h>

#define NTWindowCollectionBehaviorFullScreenPrimary (1 << 7)
#define NTFullScreenWindowMask (1 << 14)



@interface NSWindow (NisusCore)

- (void) commitEditingNisus ;

#ifdef NISUS_UNIT_TEST
- (void) setModalMouseDownLoopFakeEventsNisus:(NSArray*)events ;
#endif
- (void) enterModalMouseDownLoopWithPeriodicEventDelay:(NSTimeInterval)delay eventHandler:(void(^)(NSEvent* event, BOOL* stop))handler ;
- (void) enterModalMouseDownLoopAllowingCancel:(BOOL)isAllowCancel periodicEventDelay:(NSTimeInterval)delay eventHandler:(void(^)(NSEvent* event, BOOL isCancelled, BOOL* stop))handler ;

- (NSRect) validWindowFrameForProposedFrameNisus:(NSRect)propFrame withTitlebarHeight:(CGFloat)titlebarH ;
+ (NSRect) validWindowFrameForProposedFrameNisus:(NSRect)propFrame withTitlebarHeight:(CGFloat)titlebarH ;
+ (NSRect) validWindowFrameForProposedFrameNisus:(NSRect)propFrame withTitlebarHeight:(CGFloat)titlebarH onScreen:(NSScreen*)screen ;

// document
- (id) nisusDocument ;
- (NSWindow*) nisusDocumentWindow ;

- (BOOL) isVisibleDocumentWindow ;
- (BOOL) isVisibleWindowWithDocumentOfClass:(Class)docClass ;

// full screen
+ (BOOL) isAppleFullScreenModeActive ;
- (void) enableAppleFullScreenCollectionBehavior ;

@end



#if NISUS_DEV_BUILD
@interface NSWindow (NisusCoreDebugLog)
+ (void) nisusEnableLogFirstResponderChanges ;
+ (void) nisusEnableLogKeyWindowChanges ;
+ (void) nisusEnableLogFrameChanges ;
@end
#endif

