//
//  NisusMutableOrderedSet.h
//  NisusCore
//
//  Created by Martin on 2019.07.22.
//  Copyright © 2019 Nisus. All rights reserved.
//
//	This is a set that also maintains the order of the objects that have been added.
//	Here "order" means the order in which the object was added (first object added is at index zero), not a sort order.
//	NOTE: adding an object to the set multiple times does NOT result in duplicates nor change its ordering.

#import <Foundation/Foundation.h>
#import <NisusCore/NisusCollection.h>


@interface NisusMutableOrderedSet : NSObject <NisusCollection, NisusMutableCollection>

- (instancetype) initWithCapacity:(NSUInteger)capacity equalityOptions:(NSPointerFunctionsOptions)ops ;

- (NSUInteger) count ;
- (id) objectAtIndex:(NSUInteger)idx ;
- (id) objectAtIndexedSubscript:(NSUInteger)idx ;
- (BOOL) containsObject:(id)findObject ;
- (NSUInteger) indexForObject:(id)findObject ;

- (void) addObject:(id)addObj ;
- (void) removeObject:(id)removeObj ;
- (void) removeObjectAtIndex:(NSUInteger)removeIndex ;
- (void) removeAllObjects ;

@end
