//
//  NisusRadioButtonContainer.h
//  NisusCore
//
//  Created by Martin on 2018.07.10.
//  Copyright © 2018 Nisus. All rights reserved.
//
//	This view helps to collect together a set of related radio buttons. Other subviews are permitted but ignored except for sizing.
//	Use this view as a simple replacement for NSMatrix, since that class is no longer en vogue and doesn't work well with autolayout.
//
//	This view does these things:
//		- allows easily manipulating which radio button is selected amongst the group
//		- autosizes its width to show all subviews completely; height should be fixed at design time
//		- sends its action whenever any subview buttons are clicked

#import <Cocoa/Cocoa.h>


@interface NisusRadioButtonContainer : NSControl

@property NSInteger selectedTag ;

- (NSButton*) selectedButton ;
- (NSButton*) buttonWithTag:(NSInteger)tag ;
- (NSButton*) buttonPassingTest:(BOOL(^)(NSButton* button))test ;

@end

